import com.nokia.mid.cenrep.CentralRepository;
import com.nokia.mid.cenrep.CentralRepositoryException;
import java.io.PrintStream;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.StringItem;

public class CentralRepositoryTest extends MIDlet
    implements CommandListener
{

    private final String SECURITY_POLICY_REPOSITORY_ID = "0x2001B289";
    private final String KEY1 = "0x3";
    private final String KEY2 = "0x4";
   
    private Form mForm;
    private Command cmdExit;
    private Command cmdTest1;
    
    public CentralRepositoryTest()
    {
        mForm = new Form("Central Repository Test");
        cmdExit = new Command("Exit", 7, 1);
        mForm.addCommand(cmdExit);
        cmdTest1 = new Command("Read Java Security Policy DB", 1, 1);
        mForm.addCommand(cmdTest1);
       
        mForm.setCommandListener(this);
    }

    protected void destroyApp(boolean flag)
        throws MIDletStateChangeException
    {
    }

    protected void pauseApp()
    {
    }

    protected void startApp()
        throws MIDletStateChangeException
    {
        Display.getDisplay(this).setCurrent(mForm);
    }

    public void commandAction(Command cmd, Displayable arg1)
    {
        if(cmd == cmdExit)
        {
            notifyDestroyed();
        } else
        if(cmd == cmdTest1)
        {
            test1();
        }      
    }

    private void test1()
    {
        CentralRepository cenrep;
        mForm.deleteAll();
        cenrep = null;
        try
        {
            try
            {
                cenrep = CentralRepository.open(SECURITY_POLICY_REPOSITORY_ID);
                mForm.append("Repository Open\n");
            }
            catch(CentralRepositoryException e)
            {
                mForm.append("Exeption while opening Repository: SECURITY_POLICY_REPOSITORY_ID");
                mForm.append(e.toString());
            }
            try
            {
                String value1 = cenrep.getString("0x3");
                mForm.append(new StringItem("0x3 Security Policy(String)", value1));
            }
            catch(CentralRepositoryException e)
            {
                mForm.append("Exeption in getString() key = 0x3");
                mForm.append(e.toString());
            }
            try
            {
                int value2 = cenrep.getInt("0x4");                
                mForm.append(new StringItem("0x4 Security Warning(int)",Integer.toString( value2)));
            }
            catch(CentralRepositoryException e)
            {
                mForm.append("Exeption in getInt() key = 0x4");
                mForm.append(e.toString());
            }
        }
        catch(Exception e)
        {
            mForm.append("UnExpected Exception\n");
            mForm.append(e.toString());
        }
        if(cenrep != null)
        {
            try
            {
                cenrep.close();
                 mForm.append("\nRepository closed\n");
            }
            catch(CentralRepositoryException e)
            {
                mForm.append("Exeption while closing Repository: SECURITY_POLICY_REPOSITORY_ID");
                mForm.append(e.toString());
            }
        }
    }
}
